/**
* @file  file_display_fonts.h
* @brief Schnittstelle fuer die Klasse FileDisplayFonts.
*/
//////////////////////////////////////////////////////////////////////
#pragma once
#ifndef FILE_DISPLAY_FONTS_H
#define FILE_DISPLAY_FONTS_H

#ifdef _MSC_VER
#pragma warning(disable : 4996)
#endif

// Verwaltungsklasse fuer Datei
#include "file_intel_hex.h"

// Strukturdefinitionen
#include "interface/display_fonts_structs.h"

#include <array>

class FileDisplayFonts : public FileIntelHex
{
public:
    FileDisplayFonts();
    virtual ~FileDisplayFonts();

public:
    void resetData();

public:
    enum { max_fonts = 10 };
    // Verwaltungsstrukturen fuer Zeichensatz
    FONTNODE *m_pFontNode;
    std::array<FONT *, max_fonts> m_pFont;

public:
    bool load( const std::string &filePath );
    bool save( const std::string &filePath, bool appendToFile = false, bool appendEndLine = true );
    int AppendSegmentText( unsigned char *buf, unsigned int size );
    void FontCorrect( int iNum, bool onlyDigits );

    void Default( unsigned char count );
    void setSizeData( std::size_t size );

protected:
    bool loadBin( std::ifstream &fs, std::size_t size );
    bool saveBin( std::ofstream &fs );
};

#endif

